
'xConfirm  3800                                                          
'xErrors   2200

#COMPILE EXE
#DIM ALL
          


%NORMAL_PRIORITY_CLASS       = &H00000020         
%HIGH_PRIORITY_CLASS         = &H00000080
%REALTIME_PRIORITY_CLASS     = &H00000100
              

DECLARE FUNCTION GetCurrentProcess LIB "KERNEL32.DLL" ALIAS "GetCurrentProcess" () AS LONG
DECLARE FUNCTION SetPriorityClass  LIB "KERNEL32.DLL" ALIAS "SetPriorityClass" (BYVAL hProcess AS DWORD, BYVAL dwPriorityClass AS DWORD) AS LONG
             
           
GLOBAL CounterTSC1, CounterTSC2, CounterOverhead , CounterCycles AS QUAD
GLOBAL LoopCounter AS LONG
               


''     
MACRO COUNTER_BEGIN( nLoops, priority_class ) ' Michael W

    CounterOverhead = 2000000000
    CounterCycles   = 2000000000

    CALL SetPriorityClass( GetCurrentProcess, priority_class )

    FOR LoopCounter = 1 TO nLoops

        ! XOR eax, eax
        ! push ebx
        ! db &H0F,&HA2
        ! pop ebx
        ! db &H0F,&H31
        ! mov CounterTSC1, eax
        ! mov CounterTSC1[4], edx

        ! XOR eax, eax
        ! push ebx
        ! db &H0F,&HA2
        ! pop ebx
        ! db &H0F,&H31
        ! mov CounterTSC2, eax
        ! mov CounterTSC2[4], edx

        IF (CounterTSC2 - CounterTSC1) < CounterOverhead THEN CounterOverhead = CounterTSC2 - CounterTSC1

    NEXT

    SLEEP 0

    ' To ensure that the overhead for the reference loop will match
    ' the overhead for the test loop, regardless of the position of
    ' the macro code in memory, the entry point for the reference
    ' loop should be a multiple of 16 bytes from the entry point of
    ' the test loop. The current distance is 112 bytes.
    FOR LoopCounter = 1 TO nLoops

        ! XOR eax, eax
        ! push ebx
        ! db &H0F,&HA2
        ! pop ebx
        ! db &H0F,&H31
        ! mov CounterTSC1, eax
        ! mov CounterTSC1[4], edx

END MACRO

MACRO COUNTER_END

        ! XOR eax, eax
        ! push ebx
        ! db &H0F,&HA2
        ! pop ebx
        ! db &H0F,&H31
        ! mov CounterTSC2, eax
        ! mov CounterTSC2[4], edx

        IF (CounterTSC2 - CounterTSC1) < CounterCycles THEN CounterCycles = CounterTSC2 - CounterTSC1

    NEXT

    CALL SetPriorityClass( GetCurrentProcess, %NORMAL_PRIORITY_CLASS )
    CounterCycles = CounterCycles - CounterOverhead

END MACRO
              

''
SUB time_stamp_count(tick AS QUAD) ' CPU Clock count  Charles E V Pegge

  '---------------------------'
  '                           ' approx because it is not a serialised instruction
  '                           ' it may execute before or after other instructions
  '                           ' in the pipeline.
  ! mov ebx,tick              ' var address where count is to be stored.
  ! db  &h0f,&h31             ' RDTSC read time-stamp counter into edx:eax hi lo.
  ! mov [ebx],eax             ' save low order 4 bytes.
  ! mov [ebx+4],edx           ' save high order 4 bytes.
  '---------------------------'

END SUB
                   

  
'' 
FUNCTION VALS( sNum AS STRING ) AS SINGLE ' For Floats
                 
  LOCAL i, Mult, NegFlag, FracFlag AS LONG          
  LOCAL a AS BYTE PTR  
  LOCAL Sum AS SINGLE             
  
    a = STRPTR(sNum)
           
    NegFlag = 1
    Mult = 1
    FOR i = 0 TO LEN(sNum)
      SELECT CASE AS LONG @a[i] ' slightly faster than IF ELSE
        CASE 48 TO 57 ' 0 - 9  
          IF FracFlag = 0 THEN
            Sum = Sum*10 +(@a[i] - 48)  
          ELSE 
            Mult = Mult*10
            Sum = Sum + (@a[i] - 48)/Mult ' 
          END IF
 
       CASE 45 ' minus sign
          IF Sum = 0 THEN NegFlag = -1  ' first - before number
 
       CASE 46 ' decimal point
          IF Sum THEN FracFlag = 1 ' now the fractional part

      END SELECT
    NEXT i  
           
  FUNCTION = Sum * NegFlag
             
END FUNCTION
             
      
'' 
FUNCTION VALQ( sNum AS STRING) AS QUAD ' For handling Phone numbers
                 
  LOCAL i AS LONG
  LOCAL Sum, NegFlag AS QUAD            
  LOCAL a AS BYTE PTR               
  
    a = STRPTR(sNum)
           
    NegFlag = 1

    FOR i = 0 TO LEN(sNum)
      SELECT CASE AS LONG @a[i]
        CASE 48 TO 57 ' 0 - 9 
          Sum = Sum*10 + @a[i] - 48 '
                
       CASE 45 ' minus sign
          IF Sum = 0 THEN NegFlag = -1  ' first - before number

       CASE 46 ' decimal point
          EXIT FOR

      END SELECT
    NEXT i ' 
           
  FUNCTION = Sum * NegFlag 
             
END FUNCTION

''
FUNCTION VALL( sNum AS STRING) AS LONG 
' http://www.powerbasic.com/support/pbforums/showthread.php?t=14373&highlight=VAL

  LOCAL i, sum, NegFlag AS LONG   ' first 2 get registers
  LOCAL a AS BYTE PTR

    a = STRPTR(sNum)

    NegFlag = 1

    FOR i = 0 TO LEN(sNum)
      SELECT CASE AS LONG @a[i] ' slightly faster than IF ELSE
        CASE 48 TO 57 ' 0 - 9
          sum = sum*10 + @a[i] - 48

       CASE 45 ' minus sign
          IF Sum = 0 THEN NegFlag = -1  ' first - before number

       CASE 46 ' decimal point
          EXIT FOR

      END SELECT
    NEXT i

FUNCTION = Sum * NegFlag

END FUNCTION
                   

''
'  This get's it down to 90clks including the 23 clk overhead from the function call/return.
FUNCTION Paul(sNum AS ASCIIZ ) AS LONG  ' you must terminate passed string with a $NUL

  !mov edi,sNum                   ' get the pointer to the string
  !XOR edx,edx                    ' the SUM =0
  !XOR ecx,ecx                    ' the NEG flag =0
                                  ' 
                                  ' 
  !movzx eax,BYTE PTR [edi]       ' get the first character 

lp:                  
  !cmp eax,"0"                    ' is character < a "0"?
  !jl  LessThan0                  ' yes, skip to the non-digit check
  !cmp eax,"9"                    ' is it greater than a "9"?
  !jg  NextCharacter              ' yes, get next char.
                              
  'to get here it must be a digit ' 
  !imul edx,10                    ' sum=sum*10 ..
  !ADD edx,eax                    '     + digit
  !SUB edx,48                     '     - 48
  !jmp NextCharacter              ' 

LessThan0:                  
  !cmp eax,"."                    ' is it a "."
  !je done                        ' yes, then exit loop
  !cmp eax,"-"                    ' is it a "-"
  !jne NextCharacter              ' no, get next character
  !mov ecx,1                      ' set the NEG flag
                               
NextCharacter:               
  !inc edi                        ' increment the string pointer
  !movzx eax,BYTE PTR [edi]       ' get next character
  !OR eax,eax                     ' test if zero
  !jnz lp                         ' not zero, go back and do next character
                                
done:                     
  !cmp ecx,0                      ' is NEG flag set?
  !je skip                        ' no, skip next instruction
  !neg edx                        ' yes, negate answer
                                  ' 
skip:                  
  !mov FUNCTION,edx               ' WRITE answer TO FUNCTION


END FUNCTION  ' End Paul function
                   

         
''
FUNCTION PBMAIN( )
  

  LOCAL cBeg, cEnd AS QUAD  ' for time stamp, measuring cpu Clks
  LOCAL k, RetVal, nLoops AS LONG
  LOCAL sNumRem, sNum, s AS STRING 
  LOCAL zNum AS ASCIIZ * 16
           
    sNumRem  = "+?/\()$*%, " ' Stuff to remove from numbers for PB's VAL()

'    sNum = "$-2,279.59"    ' Test numbers
'    sNum = "07-01766566" 
    sNum = "27959"
    zNum = sNum

    nLoops = 1000        
         

    time_stamp_count(cBeg) ' measuring cpu Clks. The overhead just for making this call is about 25 clocks
      FOR k = 1 TO nLoops
        RetVal = VAL(sNum) ' REMOVE$( sNum, ANY sNumRem ) ) ' 420-438    460-465
      NEXT
    time_stamp_count(cEnd) ' measuring cpu Clks. The overhead just for making this call is about 25 clocks
    s = s + "VAL =" + STR$(RetVal) + ",   Clks="+STR$( (cEnd-cBeg)\nLoops ) + $CRLF 
    '=======================

    time_stamp_count(cBeg) ' measuring cpu Clks. The overhead just for making this call is about 25 clocks
      FOR k = 1 TO nLoops
        RetVal = VALL(sNum)  ' 279-299    282-311
      NEXT
    time_stamp_count(cEnd) ' measuring cpu Clks. The overhead just for making this call is about 25 clocks
    s = s + "VALL =" + STR$(RetVal) + ",  Clks="+STR$( (cEnd-cBeg)\nLoops ) + $CRLF 
    '=======================

    time_stamp_count(cBeg)
      FOR k = 1 TO nLoops  
        RetVal = Paul(zNum) ' +CHR$(0))  77-231         82-111
      NEXT
    time_stamp_count(cEnd) ' measuring cpu Clks. The overhead just for making this call is about 25 clocks
    s = s + "Paul =" + STR$(RetVal) + ",  Clks="+STR$( (cEnd-cBeg)\nLoops) + $CRLF + $CRLF
    '=======================    

         
    SLEEP 3000

    COUNTER_BEGIN(nLoops, %HIGH_PRIORITY_CLASS)
        RetVal = VAL(sNum) ' REMOVE$( sNum, ANY sNumRem ) ) ' 416-424
    COUNTER_END
    s = s + "VAL =" + STR$(RetVal) + ",  CounterCycles="+STR$(CounterCycles) + $CRLF 
    '=======================

    COUNTER_BEGIN(nLoops, %HIGH_PRIORITY_CLASS)
        RetVal = VALL(sNum)  ' 300-332
    COUNTER_END
    s = s + "VALL =" + STR$(RetVal) + ",  CounterCycles="+STR$(CounterCycles) + $CRLF
    '=======================

    COUNTER_BEGIN(nLoops, %HIGH_PRIORITY_CLASS)
        RetVal = Paul(zNum) ' 68
    COUNTER_END
    s = s + "PAUL =" + STR$(RetVal) + ",  CounterCycles="+STR$(CounterCycles) + $CRLF + $CRLF
    '======================= 


    MSGBOX s
              

END FUNCTION
''
